diff --git a/books/bookvol10.3.pamphlet b/books/bookvol10.3.pamphlet
index fb36ea7..cf3e0a7 100644
--- a/books/bookvol10.3.pamphlet
+++ b/books/bookvol10.3.pamphlet
@@ -78337,6 +78337,105 @@ PlaneAlgebraicCurvePlot(): PlottablePlaneCurveCategory _
 
 @
 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
+\section{domain PLACES Places}
+<<Places.input>>=
+)set break resume
+)sys rm -f Places.output
+)spool Places.output
+)set message test on
+)set message auto off
+)clear all
+
+--S 1 of 1
+)show Places
+--R Places K: Field  is a domain constructor
+--R Abbreviation for Places is PLACES 
+--R This constructor is exposed in this frame.
+--R Issue )edit bookvol10.3.pamphlet to see algebra source code for PLACES 
+--R
+--R------------------------------- Operations --------------------------------
+--R ?*? : (Integer,%) -> Divisor %        ?+? : (%,%) -> Divisor %
+--R -? : % -> Divisor %                   ?-? : (%,%) -> Divisor %
+--R ?=? : (%,%) -> Boolean                coerce : % -> OutputForm
+--R create : Symbol -> %                  create : List K -> %
+--R degree : % -> PositiveInteger         ?.? : (%,Integer) -> K
+--R foundPlaces : () -> List %            hash : % -> SingleInteger
+--R itsALeaf! : % -> Void                 latex : % -> String
+--R leaf? : % -> Boolean                  reduce : List % -> Divisor %
+--R ?~=? : (%,%) -> Boolean              
+--R ?+? : (%,Divisor %) -> Divisor %
+--R ?+? : (Divisor %,%) -> Divisor %
+--R ?-? : (%,Divisor %) -> Divisor %
+--R ?-? : (Divisor %,%) -> Divisor %
+--R localParam : % -> List NeitherSparseOrDensePowerSeries K
+--R setDegree! : (%,PositiveInteger) -> Void
+--R setFoundPlacesToEmpty : () -> List %
+--R setParam! : (%,List NeitherSparseOrDensePowerSeries K) -> Void
+--R
+--E 1
+
+)spool
+)lisp (bye)
+@
+<<Places.help>>=
+====================================================================
+Places examples
+====================================================================
+
+See Also:
+o )show Places
+
+@
+\pagehead{Places}{PLACES}
+\pagepic{ps/v103places.eps}{PLACES}{1.00}
+
+{\bf Exports:}\\
+\begin{tabular}{lllll}
+\cross{PLACES}{-?} &
+\cross{PLACES}{?*?} &
+\cross{PLACES}{?+?} &
+\cross{PLACES}{?-?} &
+\cross{PLACES}{?.?} \\
+\cross{PLACES}{?=?} &
+\cross{PLACES}{?\~{}=?} &
+\cross{PLACES}{coerce} &
+\cross{PLACES}{create} &
+\cross{PLACES}{degree} &
+\cross{PLACES}{foundPlaces} \\
+\cross{PLACES}{hash} &
+\cross{PLACES}{itsALeaf!} &
+\cross{PLACES}{latex} &
+\cross{PLACES}{leaf?} &
+\cross{PLACES}{localParam} &
+\cross{PLACES}{reduce} \\
+\cross{PLACES}{setDegree!} &
+\cross{PLACES}{setFoundPlacesToEmpty} &
+\cross{PLACES}{setParam!} &&
+\end{tabular}
+
+<<domain PLACES Places>>=
+)abbrev domain PLACES Places
+++ Author: Gaetan Hache
+++ Date Created: 17 nov 1992
+++ Date Last Updated: May 2010 by Tim Daly
+++ Description:  
+++ The following is part of the PAFF package
+Places(K):Exports == Implementation where
+  K:Field
+  PCS    ==>  NeitherSparseOrDensePowerSeries(K)
+  
+  Exports ==> PlacesCategory(K,PCS) 
+    
+  Implementation ==>   Plcs(K,PCS)
+  
+@
+<<PLACES.dotabb>>=
+"PLACES" [color="#88FF44",href="bookvol10.3.pdf#nameddest=PLACES"];
+"NSDPS" [color="#88FF44",href="bookvol10.3.pdf#nameddest=NSDPS"];
+"PLACES" -> "NSDPS"
+
+@
+%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 \section{domain PLCS Plcs}
 <<Plcs.input>>=
 )set break resume
@@ -125901,6 +126000,7 @@ Note that this code is not included in the generated catdef.spad file.
 <<domain PARSCURV ParametricSpaceCurve>>
 <<domain PARSURF ParametricSurface>>
 <<domain PFR PartialFraction>>
+<<domain PLACES Places>>
 <<domain PRTITION Partition>>
 <<domain PATTERN Pattern>>
 <<domain PATLRES PatternMatchListResult>>
diff --git a/books/bookvol5.pamphlet b/books/bookvol5.pamphlet
index d456252..b176b4e 100644
--- a/books/bookvol5.pamphlet
+++ b/books/bookvol5.pamphlet
@@ -24089,6 +24089,7 @@ otherwise the new algebra won't be loaded by the interpreter when needed.
    (|Permutation| . PERM)
    (|Pi| . HACKPI)
    (|PiCoercions| . PICOERCE)
+   (|Places| . PLACES)
    (|Plcs| . PLCS)
    (|PointFunctions2| . PTFUNC2)
    (|PolyGroebner| . PGROEB)
diff --git a/books/ps/v103places.eps b/books/ps/v103places.eps
new file mode 100644
index 0000000..0a5fd47
--- /dev/null
+++ b/books/ps/v103places.eps
@@ -0,0 +1,266 @@
+%!PS-Adobe-3.0 EPSF-3.0
+%%Creator: Graphviz version 2.20.2 (Mon Mar 30 10:09:11 UTC 2009)
+%%For: (root) root
+%%Title: pic
+%%Pages: 1
+%%BoundingBox: 36 36 114 152
+%%EndComments
+save
+%%BeginProlog
+/DotDict 200 dict def
+DotDict begin
+
+/setupLatin1 {
+mark
+/EncodingVector 256 array def
+ EncodingVector 0
+
+ISOLatin1Encoding 0 255 getinterval putinterval
+EncodingVector 45 /hyphen put
+
+% Set up ISO Latin 1 character encoding
+/starnetISO {
+        dup dup findfont dup length dict begin
+        { 1 index /FID ne { def }{ pop pop } ifelse
+        } forall
+        /Encoding EncodingVector def
+        currentdict end definefont
+} def
+/Times-Roman starnetISO def
+/Times-Italic starnetISO def
+/Times-Bold starnetISO def
+/Times-BoldItalic starnetISO def
+/Helvetica starnetISO def
+/Helvetica-Oblique starnetISO def
+/Helvetica-Bold starnetISO def
+/Helvetica-BoldOblique starnetISO def
+/Courier starnetISO def
+/Courier-Oblique starnetISO def
+/Courier-Bold starnetISO def
+/Courier-BoldOblique starnetISO def
+cleartomark
+} bind def
+
+%%BeginResource: procset graphviz 0 0
+/coord-font-family /Times-Roman def
+/default-font-family /Times-Roman def
+/coordfont coord-font-family findfont 8 scalefont def
+
+/InvScaleFactor 1.0 def
+/set_scale {
+       dup 1 exch div /InvScaleFactor exch def
+       scale
+} bind def
+
+% styles
+/solid { [] 0 setdash } bind def
+/dashed { [9 InvScaleFactor mul dup ] 0 setdash } bind def
+/dotted { [1 InvScaleFactor mul 6 InvScaleFactor mul] 0 setdash } bind def
+/invis {/fill {newpath} def /stroke {newpath} def /show {pop newpath} def} bind def
+/bold { 2 setlinewidth } bind def
+/filled { } bind def
+/unfilled { } bind def
+/rounded { } bind def
+/diagonals { } bind def
+
+% hooks for setting color 
+/nodecolor { sethsbcolor } bind def
+/edgecolor { sethsbcolor } bind def
+/graphcolor { sethsbcolor } bind def
+/nopcolor {pop pop pop} bind def
+
+/beginpage {	% i j npages
+	/npages exch def
+	/j exch def
+	/i exch def
+	/str 10 string def
+	npages 1 gt {
+		gsave
+			coordfont setfont
+			0 0 moveto
+			(\() show i str cvs show (,) show j str cvs show (\)) show
+		grestore
+	} if
+} bind def
+
+/set_font {
+	findfont exch
+	scalefont setfont
+} def
+
+% draw text fitted to its expected width
+/alignedtext {			% width text
+	/text exch def
+	/width exch def
+	gsave
+		width 0 gt {
+			[] 0 setdash
+			text stringwidth pop width exch sub text length div 0 text ashow
+		} if
+	grestore
+} def
+
+/boxprim {				% xcorner ycorner xsize ysize
+		4 2 roll
+		moveto
+		2 copy
+		exch 0 rlineto
+		0 exch rlineto
+		pop neg 0 rlineto
+		closepath
+} bind def
+
+/ellipse_path {
+	/ry exch def
+	/rx exch def
+	/y exch def
+	/x exch def
+	matrix currentmatrix
+	newpath
+	x y translate
+	rx ry scale
+	0 0 1 0 360 arc
+	setmatrix
+} bind def
+
+/endpage { showpage } bind def
+/showpage { } def
+
+/layercolorseq
+	[	% layer color sequence - darkest to lightest
+		[0 0 0]
+		[.2 .8 .8]
+		[.4 .8 .8]
+		[.6 .8 .8]
+		[.8 .8 .8]
+	]
+def
+
+/layerlen layercolorseq length def
+
+/setlayer {/maxlayer exch def /curlayer exch def
+	layercolorseq curlayer 1 sub layerlen mod get
+	aload pop sethsbcolor
+	/nodecolor {nopcolor} def
+	/edgecolor {nopcolor} def
+	/graphcolor {nopcolor} def
+} bind def
+
+/onlayer { curlayer ne {invis} if } def
+
+/onlayers {
+	/myupper exch def
+	/mylower exch def
+	curlayer mylower lt
+	curlayer myupper gt
+	or
+	{invis} if
+} def
+
+/curlayer 0 def
+
+%%EndResource
+%%EndProlog
+%%BeginSetup
+14 default-font-family set_font
+1 setmiterlimit
+% /arrowlength 10 def
+% /arrowwidth 5 def
+
+% make sure pdfmark is harmless for PS-interpreters other than Distiller
+/pdfmark where {pop} {userdict /pdfmark /cleartomark load put} ifelse
+% make '<<' and '>>' safe on PS Level 1 devices
+/languagelevel where {pop languagelevel}{1} ifelse
+2 lt {
+    userdict (<<) cvn ([) cvn load put
+    userdict (>>) cvn ([) cvn load put
+} if
+
+%%EndSetup
+setupLatin1
+%%Page: 1 1
+%%PageBoundingBox: 36 36 114 152
+%%PageOrientation: Portrait
+0 0 1 beginpage
+gsave
+36 36 78 116 boxprim clip newpath
+1 1 set_scale 0 rotate 40 40 translate
+% PLACES
+gsave
+[ /Rect [ 0 72 70 108 ]
+  /Border [ 0 0 0 ]
+  /Action << /Subtype /URI /URI (bookvol10.3.pdf#nameddest=PLACES) >>
+  /Subtype /Link
+/ANN pdfmark
+0.273 0.733 1.000 nodecolor
+newpath 70 108 moveto
+0 108 lineto
+0 72 lineto
+70 72 lineto
+closepath fill
+1 setlinewidth
+filled
+0.273 0.733 1.000 nodecolor
+newpath 70 108 moveto
+0 108 lineto
+0 72 lineto
+70 72 lineto
+closepath stroke
+0.000 0.000 0.000 nodecolor
+14 /Times-Roman set_font
+7.5 85.9 moveto 55 (PLACES) alignedtext
+grestore
+% NSDPS
+gsave
+[ /Rect [ 3 0 67 36 ]
+  /Border [ 0 0 0 ]
+  /Action << /Subtype /URI /URI (bookvol10.3.pdf#nameddest=NSDPS) >>
+  /Subtype /Link
+/ANN pdfmark
+0.273 0.733 1.000 nodecolor
+newpath 67 36 moveto
+3 36 lineto
+3 0 lineto
+67 0 lineto
+closepath fill
+1 setlinewidth
+filled
+0.273 0.733 1.000 nodecolor
+newpath 67 36 moveto
+3 36 lineto
+3 0 lineto
+67 0 lineto
+closepath stroke
+0.000 0.000 0.000 nodecolor
+14 /Times-Roman set_font
+10.5 13.9 moveto 49 (NSDPS) alignedtext
+grestore
+% PLACES->NSDPS
+gsave
+1 setlinewidth
+0.000 0.000 0.000 edgecolor
+newpath 35 72 moveto
+35 64 35 55 35 46 curveto
+stroke
+0.000 0.000 0.000 edgecolor
+newpath 38.5 46 moveto
+35 36 lineto
+31.5 46 lineto
+closepath fill
+1 setlinewidth
+solid
+0.000 0.000 0.000 edgecolor
+newpath 38.5 46 moveto
+35 36 lineto
+31.5 46 lineto
+closepath stroke
+grestore
+endpage
+showpage
+grestore
+%%PageTrailer
+%%EndPage: 1
+%%Trailer
+end
+restore
+%%EOF
diff --git a/changelog b/changelog
index 32d038a..4835dd3 100644
--- a/changelog
+++ b/changelog
@@ -1,3 +1,8 @@
+20100518 tpd src/axiom-website/patches.html 20100518.01.tpd.patch
+20100518 tpd src/algebra/Makefile help and test for Places
+20100518 tpd books/bookvol5 expose Places
+20100518 tpd books/bookvol10.3 add Places
+20100518 tpd books/ps/v103places.eps added
 20100517 tpd src/axiom-website/patches.html 20100517.05.tpd.patch
 20100517 tpd src/algebra/Makefile help and test for Plcs
 20100517 tpd books/bookvol5 expose Plcs
diff --git a/src/algebra/Makefile.pamphlet b/src/algebra/Makefile.pamphlet
index 4c941a2..26409f6 100644
--- a/src/algebra/Makefile.pamphlet
+++ b/src/algebra/Makefile.pamphlet
@@ -12079,7 +12079,7 @@ LAYER16=\
 
 @
 \subsection{Layer17}
-Depends on: ACF COMPCAT FFCAT FRNAALG FS OC QUATCAT RPOLCAT UTSCAT\\
+Depends on: ACF COMPCAT FFCAT FRNAALG FS OC QUATCAT RPOLCAT UTSCAT NSDPS \\
 Used by next layer: ACFS EXPRSOL FDIVCAT UFPS ULSCCAT UTSSOL 
 
 The clique1.spad file is used because "MYEXPR" and "MYUP" are 
@@ -12112,13 +12112,14 @@ LAYER17=\
   ${OUT}/INTEF.o    ${OUT}/INTG0.o    ${OUT}/INTHERAL.o ${OUT}/INTPAF.o   \
   ${OUT}/INTPM.o    ${OUT}/INTTOOLS.o ${OUT}/ITRIGMNP.o ${OUT}/JORDAN.o   \
   ${OUT}/KOVACIC.o  ${OUT}/LF.o       ${OUT}/LIE.o      ${OUT}/LODOF.o    \
-  ${OUT}/LSQM.o     ${OUT}/OMEXPR.o   ${OUT}/MCMPLX.o   ${OUT}/MULTFACT.o \
+  ${OUT}/LSQM.o     ${OUT}/MCMPLX.o   ${OUT}/MULTFACT.o \
   ${MID}/clique1.spad \
   ${OUT}/NAGF01.o   ${OUT}/NAGF02.o   ${OUT}/NAGF04.o   ${OUT}/NCEP.o     \
   ${OUT}/NLINSOL.o  ${OUT}/NSMP.o     ${OUT}/NUMERIC.o  ${OUT}/OCT.o      \
-  ${OUT}/OCTCT2.o   ${OUT}/ODEPAL.o   ${OUT}/ODERTRIC.o ${OUT}/PACEXTC.o  \
-  ${OUT}/PADE.o     \
+  ${OUT}/OCTCT2.o   ${OUT}/ODEPAL.o   ${OUT}/ODERTRIC.o ${OUT}/OMEXPR.o   \
+  ${OUT}/PACEXTC.o  ${OUT}/PADE.o     \
   ${OUT}/PAN2EXPR.o ${OUT}/PFO.o      ${OUT}/PFOQ.o     ${OUT}/PICOERCE.o \
+  ${OUT}/PLACES.o   \
   ${OUT}/PMASSFS.o  ${OUT}/PMFS.o     ${OUT}/PMPREDFS.o ${OUT}/PROJPLPS.o \
   ${OUT}/PSETPK.o   \
   ${OUT}/QUAT.o     ${OUT}/QUATCT2.o  ${OUT}/RADFF.o    ${OUT}/RDEEF.o    \
@@ -14107,6 +14108,16 @@ LAYER17=\
 /*"PFOQ" -> {"ABELGRP-"; "ABELMON-"; "VECTCAT"; "A1AGG"; "FLAGG"; "LNAGG"}*/
 /*"PFOQ" -> {"IXAGG"; "HOAGG"; "AGG"; "ELTAGG"; "CLAGG"}*/
 
+"PLACES" [color="#88FF44",href="bookvol10.3.pdf#nameddest=PLACES"]
+/*"PLACES" -> {"PLACESC"; "SETCATD"; "LOCPOWC"; "DIV"}*/
+"PLACES" -> "NSDPS"
+"PLACES" -> "PLCS"
+/*"PLACES" -> {"SETCAT"; "BASTYPE"; "KOERCE"; "FIELD"; "EUCDOM"}*/
+/*"PLACES" -> {"PID"; "GCDDOM"; "INTDOM"; "COMRING"; "RING"}*/
+/*"PLACES" -> {"RNG"; "ABELGRP"; "CABMON"; "ABELMON"; "ABELSG"}*/
+/*"PLACES" -> {"SGROUP"; "MONOID"; "LMODULE"; "BMODULE"; "RMODULE"}*/
+/*"PLACES" -> {"ALGEBRA"; "MODULE"; "ENTIRER"; "UFD"; "DIVRING"}*/
+
 "PICOERCE" [color="#FF4488",href="bookvol10.4.pdf#nameddest=PICOERCE"]
 /*"PICOERCE" -> {"ORDSET"; "SETCAT"; "BASTYPE"; "KOERCE"; "INTDOM"}*/
 /*"PICOERCE" -> {"COMRING"; "RING"; "RNG"; "ABELGRP"; "CABMON"; "ABELMON"}*/
@@ -16553,6 +16564,21 @@ ${MID}/PLCS.nrlib/code.o: ${MID}/PLCS.spad
 	      | ${INTERPSYS} >${TMP}/trace ; \
 	   fi )
 @
+<<newcode>>=
+ 
+PLACESDEPS = NSDPS SETCATD PLACESC PLCS LOCPOWC DIV
+
+${MID}/PLACES.nrlib/code.o: ${MID}/PLACES.spad
+	@echo P3 making ${MID}/PLACES.nrlib/code.o from ${MID}/PLACES.spad
+	@ (cd ${MID} ; \
+	   if [ -z "${NOISE}" ] ; then \
+	    echo -e ")lib ${PLACESDEPS} \n )co PLACES.spad" \
+              | ${INTERPSYS} ; \
+           else \
+	    echo -e ")lib ${PLACESDEPS} \n )co PLACES.spad" \
+	      | ${INTERPSYS} >${TMP}/trace ; \
+	   fi )
+@
 
 \section{Broken Files}
 These files are Aldor files
@@ -17374,6 +17400,7 @@ SPADHELP=\
  ${HELP}/PartialFractionPackage.help \
  ${HELP}/Permanent.help \
  ${HELP}/Permutation.help \
+ ${HELP}/Places.help \
  ${HELP}/PlacesCategory.help \
  ${HELP}/PlaneAlgebraicCurvePlot.help \
  ${HELP}/Plcs.help \
@@ -17549,6 +17576,7 @@ REGRESS= \
  PartialFractionPackage.regress \
  Permanent.regress \
  Permutation.regress \
+ Places.regress \
  PlacesCategory.regress \
  PlaneAlgebraicCurvePlot.regress \
  Plcs.regress \
@@ -18874,8 +18902,20 @@ ${HELP}/Permutation.help: ${BOOKS}/bookvol10.3.pamphlet
             >${INPUT}/Permutation.input
 	@echo "Permutation (PERM)" >>${HELPFILE}
 
+${HELP}/Places.help: ${BOOKS}/bookvol10.3.pamphlet
+	@echo 7905 create Places.help from \
+            ${BOOKS}/bookvol10.3.pamphlet
+	@${TANGLE} -R"Places.help" \
+          ${BOOKS}/bookvol10.3.pamphlet \
+           >${HELP}/Places.help
+	@cp ${HELP}/Places.help ${HELP}/PLACES.help
+	@${TANGLE} -R"Places.input" \
+           ${BOOKS}/bookvol10.3.pamphlet \
+            >${INPUT}/Places.input
+	@echo "Places (PLACES)" >>${HELPFILE}
+
 ${HELP}/PlacesCategory.help: ${BOOKS}/bookvol10.2.pamphlet
-	@echo 7905 create PlacesCategory.help from \
+	@echo 7907 create PlacesCategory.help from \
             ${BOOKS}/bookvol10.2.pamphlet
 	@${TANGLE} -R"PlacesCategory.help" \
           ${BOOKS}/bookvol10.2.pamphlet \
diff --git a/src/axiom-website/patches.html b/src/axiom-website/patches.html
index a1d4b45..7de6b8f 100644
--- a/src/axiom-website/patches.html
+++ b/src/axiom-website/patches.html
@@ -2747,5 +2747,7 @@ books/bookvol10.3 add Divisor<br/>
 books/bookvol10.2 fix the image to use .eps<br/>
 <a href="patches/20100517.05.tpd.patch">20100517.05.tpd.patch</a>
 books/bookvol10.3 add Plcs<br/>
+<a href="patches/20100518.01.tpd.patch">20100518.01.tpd.patch</a>
+books/bookvol10.3 add Places<br/>
  </body>
 </html>
